SystemOrganization addCategory: #NewList!
SystemOrganization addCategory: #'NewList-Example'!

ScrollPane subclass: #NewList
	instanceVariableNames: 'listCache model listSize isInitialized isMultipleSelection selectedIndex selectedIndexes renderer headerHeight headerTitle clickOnHeader lastKeystrokeTime lastKeystrokes secondSelection displayListCache deSelectOnReclick runningProcesses selectionWithKeys drawColor selectedItem selectedItems unselectOnChange iconCache iconMaxSize enabled'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewList'!

!NewList commentStamp: '<historical>' prior: 0!
NewList is a new morph as replacement for PluggableListMorph.

The API used is hardcoded, but NewListAdapter has been introduced to hold this "pluggable" behavior!

!NewList class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 11/26/2012 18:38'!
adapterOn: aModel

	^ NewListAdapter on: aModel! !

!NewList class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 11/26/2012 18:35'!
on: aListModel

	^ self new
		model: aListModel;
		yourself! !

!NewList class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 12/13/2012 12:25'!
on: aModel getItemsSelector: getItems getDisplaySelector: getDisplay
	
	| listModel instance |
	listModel := self adapterOn: aModel.
	
	listModel
		on: aModel 
		getItemsSelector: getItems
		getDisplaySelector: getDisplay.
	
	instance := self on: listModel.
	listModel list: instance.
	
	^ instance! !

!NewList class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 11/26/2012 18:51'!
on: aModel getItemsSelector: getItems setIndexSelector: setIndex getDisplaySelector: getDisplay
	
	| listModel instance |
	listModel := self adapterOn: aModel.
	
	listModel
		on: aModel 
		getItemsSelector: getItems 
		setIndexSelector: setIndex 
		getDisplaySelector: getDisplay.
	
	instance := self on: listModel.
	listModel list: instance.
	
	^ instance! !

!NewList methodsFor: 'communication with model' stamp: 'BenjaminVanRyseghem 11/27/2012 00:39'!
acceptDroppingMorph: aMorph atIndex: index event: evt

	^ self model acceptDroppingMorph: aMorph atIndex: index event: evt! !

!NewList methodsFor: 'communication with model' stamp: 'BenjaminVanRyseghem 11/26/2012 18:54'!
adapter

	^ self model! !

!NewList methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 11/29/2012 17:50'!
addAtIndexes: anIndex
	
	selectedIndexes at: anIndex put: true! !

!NewList methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 12/16/2012 19:15'!
adoptIndexes: aDictionary

	selectedIndexes contents: aDictionary! !

!NewList methodsFor: 'looks & colors' stamp: 'BenjaminVanRyseghem 11/29/2012 19:42'!
backgroundColor: aColor

	self drawColor: aColor! !

!NewList methodsFor: 'events - keyboard' stamp: 'BenjaminVanRyseghem 11/29/2012 20:02'!
basicKeyPressed: aChar 
	| nextSelection milliSeconds slowKeyStroke  nextSelectionText oldSelection |
	
	nextSelection := oldSelection := self selectedIndex.
	milliSeconds := Time millisecondClockValue.
	slowKeyStroke := milliSeconds - lastKeystrokeTime > 500.
	lastKeystrokeTime := milliSeconds.
	
	aChar = Character space
		ifTrue: [ 
			self clickOnSelectedItem.
			^ self secondSelection: 0 ].
	
	self ensureFullDisplayListCache.
		
	slowKeyStroke
		ifTrue: ["forget previous keystrokes and search in following elements"
			lastKeystrokes := aChar asLowercase asString.]
		ifFalse: ["append quick keystrokes but don't move selection if it still matches"
			lastKeystrokes :=String streamContents: [:s | s << lastKeystrokes << aChar asLowercase asString ]].
	"Get rid of blanks and style used in some lists"
	nextSelection := displayListCache findFirst: [:a | a 
												ifNil: [ false "in case it's not loaded yet" ]
												ifNotNil: [:e | e beginsWith: lastKeystrokes fromList: self ]].
	nextSelection isZero ifTrue: [ ^ self secondSelection: 0 ].
	
	"No change if model is locked"
	model okToChange ifFalse: [ ^ self ].	"No change if model is locked"

	"The following line is a workaround around the behaviour of OBColumn>>selection:,
	 which deselects when called twice with the same argument."
	oldSelection = nextSelection ifTrue: [ ^ self ].
	
	self secondSelection: nextSelection. ! !

!NewList methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 11/29/2012 19:51'!
cacheAt: index

	^ listCache contents at: index ifAbsent: [ ^ nil ]! !

!NewList methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 11/25/2012 02:21'!
clickOnSelectedItem
	| item |

	item := self itemAtIndex: self selectedIndex.
	(item respondsTo: #click:)
		ifTrue: [ item click: MouseEvent new ]! !

!NewList methodsFor: 'looks & colors' stamp: 'BenjaminVanRyseghem 11/24/2012 14:48'!
colorForItem: item at: index

	^ (self isSelectedIndex: index)
		ifTrue: [ self theme currentSettings selectionTextColor ]
		ifFalse: [ self defaultItemColor ]! !

!NewList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/26/2012 18:30'!
deSelectOnReclick
	^ deSelectOnReclick contents! !

!NewList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/26/2012 18:31'!
deSelectOnReclick: anObject
	deSelectOnReclick contents: anObject! !

!NewList methodsFor: 'looks & colors' stamp: 'BenjaminVanRyseghem 11/23/2012 15:03'!
defaultItemColor

	^ Color black! !

!NewList methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 11/29/2012 20:07'!
deselectAll

	self isMultipleSelection ifFalse: [ ^ self ].
	
	selectedIndexes removeAll.
	self secondSelection: 0.
	selectedIndex contents: 0.
	self changed.! !

!NewList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2012 19:41'!
drawColor
	^ drawColor contents! !

!NewList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2012 19:41'!
drawColor: anObject
	drawColor contents: anObject! !

!NewList methodsFor: 'drawing' stamp: 'BenjaminVanRyseghem 12/13/2012 11:36'!
drawOn: aCanvas

	aCanvas
		fillRectangle: self fullBounds
		color: self drawColor.! !

!NewList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/13/2012 11:23'!
enabled: aBoolean
	"Set the value of enabled"

	enabled contents = aBoolean ifTrue: [^self].
	enabled contents: aBoolean.
	self changed: #enabled.
	self
		adoptPaneColor: self paneColor;
		changed! !

!NewList methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 12/16/2012 17:53'!
endOfInitialization

	isInitialized contents: true.

	self updateItems.
	self updateDisplayListCache.
	self updateListSize.
	self updateHeaderTitle.
	self updateHeaderHeight.
	
	self updateRenderer.
	
	selectedItem contents: self retrieveSelectedItem.
	selectedItems contents: self retrieveSelectedItems.
	
	listCache whenChangedDo: [:e |
			listSize contents: e size.
			self updateDisplayListCache.
			self unselectOnChange
				ifTrue: [ self deselectAll ].
			self updateScrollbars ].
	listSize whenChangedDo: [:e | self updateRenderer ].
	headerTitle whenChangedDo:[:e | self updateHeaderHeight ].
	secondSelection whenChangedDo: [:idx | 
		self setViewToIndex: idx. 
		self renderer updateRectFor: idx ].
	selectedIndex whenChangedDo: [:newIndex :oldIndex | 
		selectedItem contents: self retrieveSelectedItem.
		self renderer updateRectFor: oldIndex. ].
	selectedIndexes whenChangedDo: [:newIndex :oldIndex | selectedItems contents: self retrieveSelectedItems ].
	headerTitle whenChangedDo: [:t | self renderer invalidHeader ].! !

!NewList methodsFor: 'updating - private' stamp: 'BenjaminVanRyseghem 11/27/2012 01:33'!
ensureFullDisplayListCache

	[ listCache doWithIndex: [:e :i || process |
		process := [ | item |
			item := self model getDisplayForItem: e at: i.
			(displayListCache at: i) ifNil: [
			displayListCache at: i put: item ]] fork.
		
		runningProcesses at: i put: process ]] fork. ! !

!NewList methodsFor: 'geometry' stamp: 'BenjaminVanRyseghem 11/24/2012 01:32'!
extent: newExtent
	super extent: newExtent.
	
	"Change listMorph's bounds to the new width. It is either the size
	of the widest list item, or the size of self, whatever is bigger"
	self renderer ifNil: [ ^ self  ].
	self renderer width: ((self width-40) max: (self renderer maxWidth))! !

!NewList methodsFor: 'looks & colors' stamp: 'BenjaminVanRyseghem 11/23/2012 16:05'!
font

	^ self theme listFont! !

!NewList methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 11/27/2012 01:02'!
getMenu: shiftKeyState
	
	^ self model getMenu: shiftKeyState.! !

!NewList methodsFor: 'communication with model' stamp: 'BenjaminVanRyseghem 11/26/2012 21:10'!
handlesDoubleClick

	^ self model handlesDoubleClick! !

!NewList methodsFor: 'events - keyboard' stamp: 'BenjaminVanRyseghem 11/25/2012 00:31'!
handlesKeyStroke: anEvet

	^ true! !

!NewList methodsFor: 'private' stamp: 'BenjaminVanRyseghem 11/26/2012 21:07'!
hasHeader

	^ headerHeight contents ~~ 0! !

!NewList methodsFor: 'private' stamp: 'BenjaminVanRyseghem 11/26/2012 18:48'!
hasHeader: aBoolean

	self renderer hasHeader: aBoolean ! !

!NewList methodsFor: 'private' stamp: 'BenjaminVanRyseghem 11/29/2012 19:17'!
hasMultipledSelected
	| int |
	
	int := 0.
	selectedIndexes do: [:ass |
		ass value ifTrue: [ int := int + 1 ].
		int = 2 ifTrue: [ ^ true ]].
	^ false! !

!NewList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/26/2012 18:30'!
headerHeight
	^ headerHeight contents! !

!NewList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/26/2012 18:31'!
headerHeight: anObject
	headerHeight contents: anObject! !

!NewList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/26/2012 18:30'!
headerTitle
	^ headerTitle contents! !

!NewList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/26/2012 18:31'!
headerTitle: anObject
	headerTitle contents: anObject! !

!NewList methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 1/26/2013 01:53'!
iconForItem: anItem at: anIndex

	^ iconCache 
		at: anItem
		ifAbsentPut: [ (self model iconForItem: anItem at: anIndex) asMorph ]! !

!NewList methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 1/26/2013 01:50'!
iconMaxSize

	^ iconMaxSize contents ifNil: [ 
		iconMaxSize contents: self retrieveIconMaxSize ]! !

!NewList methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 12/16/2012 18:44'!
initialize
	"Initialization code for NewList"

	renderer := nil asValueHolder.
	super initialize.
	
	lastKeystrokeTime := 0.
	lastKeystrokes := ''.
	
	drawColor := Color white asValueHolder.
	model := nil asValueHolder.
	isInitialized := false asValueHolder.
	isMultipleSelection := false asValueHolder.
	listCache := OrderedCollection new asValueHolder.
	selectedIndex := 0 asValueHolder.
	selectedIndexes := Dictionary new asValueHolder.
	listSize := nil asValueHolder.
	headerHeight := 0 asValueHolder.
	headerTitle := '' asValueHolder.
	clickOnHeader := nil asValueHolder.
	secondSelection := nil asValueHolder.
	displayListCache := OrderedCollection new asValueHolder.
	runningProcesses := Array new asValueHolder.
	deSelectOnReclick := false asValueHolder.
	selectionWithKeys := true asValueHolder.
	selectedItem := nil asValueHolder.
	selectedItems := OrderedCollection new asValueHolder.
	unselectOnChange := false asValueHolder.
	iconCache := Dictionary new asValueHolder.
	iconMaxSize := nil asValueHolder.
	enabled := true asValueHolder.! !

!NewList methodsFor: 'updating' stamp: 'BenjaminVanRyseghem 12/17/2012 14:57'!
invalidateIconCache

	iconCache removeAll! !

!NewList methodsFor: 'updating' stamp: 'BenjaminVanRyseghem 12/13/2012 11:09'!
invalidateIconCacheFor: anItem

	iconCache removeKey: anItem! !

!NewList methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 11/29/2012 17:51'!
inverseSelection

	self isMultipleSelection ifFalse: [ ^ self ].
	
	1 to: self listSize do: [: i | self toggleAtIndexes: i ].
	self secondSelection: 0.
	selectedIndex contents: self selectedIndexes first.
	self changed.! !

!NewList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/26/2012 18:30'!
isInitialized
	^ isInitialized contents! !

!NewList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/26/2012 18:31'!
isInitialized: anObject
	isInitialized contents: anObject! !

!NewList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/26/2012 18:30'!
isMultipleSelection
	^ isMultipleSelection contents! !

!NewList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/26/2012 18:31'!
isMultipleSelection: anObject
	isMultipleSelection contents: anObject! !

!NewList methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 11/25/2012 01:47'!
isSecondSelectedIndex: anIndex
	
	^ self secondSelection == anIndex! !

!NewList methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 11/29/2012 16:30'!
isSelectedIndex: index

	^ self isMultipleSelection
 		ifTrue: [ selectedIndexes at: index ifAbsent: [ ^false ]]
		ifFalse: [ self selectedIndex = index ]! !

!NewList methodsFor: 'communication with model' stamp: 'BenjaminVanRyseghem 1/28/2013 13:27'!
itemAtIndex: index

	^ (displayListCache at: index)
		ifNil: [ | item rawItem icon |
			(runningProcesses at: index) ifNotNil: [:process | 
				process terminate.
				runningProcesses remove: process ].
			rawItem := self rawItemAtIndex: index.
			icon := self iconForItem: rawItem at: index. 
			rawItem := self model getDisplayForItem: rawItem at: index.
			item := rawItem.
			displayListCache at: index put: item.
			item ]! !

!NewList methodsFor: 'private' stamp: 'BenjaminVanRyseghem 11/25/2012 00:11'!
itemHalfOffSet

	^ 1! !

!NewList methodsFor: 'private' stamp: 'BenjaminVanRyseghem 12/13/2012 09:46'!
itemHeight

	^ (self font height max: self iconMaxSize y) + (2*self itemHalfOffSet)! !

!NewList methodsFor: 'events - keyboard' stamp: 'BenjaminVanRyseghem 11/29/2012 19:10'!
keyStroke: event 
	"Process keys 
	specialKeys are things like up, down, etc. ALWAYS HANDLED 
	modifierKeys are regular characters either 1) accompanied with ctrl, 
	cmd or 2) any character if the list doesn't want to handle basic 
	keys (handlesBasicKeys returns false) 
	basicKeys are any characters"
	| aChar |

	(self scrollByKeyboard: event) ifTrue: [ ^ self ].
	(self navigationKey: event) ifTrue: [ ^ self ].
	
	(self keyStrokeAction: event) ifTrue: [ ^ self ].
	
	aChar := event keyCharacter.
	aChar asciiValue < 32 ifTrue: [^ self specialKeyPressed: event ].
	
	^ self basicKeyPressed: aChar! !

!NewList methodsFor: 'communication with model' stamp: 'BenjaminVanRyseghem 11/26/2012 21:12'!
keyStrokeAction: anEvent

	^ self model keyStrokeAction: anEvent! !

!NewList methodsFor: 'communication with model' stamp: 'BenjaminVanRyseghem 11/23/2012 14:57'!
listSize

	^ listSize contents ifNil: [ self retrieveListSize ]! !

!NewList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/26/2012 18:31'!
listSize: anObject
	listSize contents: anObject! !

!NewList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/26/2012 18:50'!
model

	^ model contents! !

!NewList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/26/2012 18:50'!
model: anObject
	
	model contents ifNotNil: [:m | m removeDependent: self ].
	anObject ifNotNil: [anObject addDependent: self ].

	model contents: anObject! !

!NewList methodsFor: 'events - mouse' stamp: 'BenjaminVanRyseghem 11/24/2012 19:08'!
mouseDownOnHeader: anEvent

	"Just to rise an announcement"
	clickOnHeader contents: anEvent! !

!NewList methodsFor: 'events - mouse' stamp: 'BenjaminVanRyseghem 11/25/2012 02:10'!
mouseDownOnItemAt: index event: anEvent
	
	| item |
	item := self itemAtIndex: index.
	(item respondsTo: #mouseDown:)
		ifTrue: [ item mouseDown: anEvent ]! !

!NewList methodsFor: 'events - mouse' stamp: 'BenjaminVanRyseghem 12/16/2012 17:07'!
mouseUp: event
	
	| newEvent |
	newEvent := event translatedBy: self topLeft negated .
	
	self renderer mouseUp: newEvent.! !

!NewList methodsFor: 'events - mouse' stamp: 'BenjaminVanRyseghem 12/13/2012 14:40'!
mouseUpOnItemAt: index event: anEvent
	
	| item |
	index isZero ifTrue: [ ^ self ].
	index > self listSize ifTrue: [ ^ self ].
	item := self itemAtIndex: index.
	(item respondsTo: #mouseDown:)
		ifTrue: [ item mouseDown: anEvent ]! !

!NewList methodsFor: 'events - keyboard' stamp: 'BenjaminVanRyseghem 11/29/2012 17:52'!
navigationKey: anEvent

	self isMultipleSelection
		ifTrue: [ | keyString |
			keyString := anEvent keyString.
			keyString = '<Cmd-a>'
				ifTrue: [ 
					self selectAll.
					^ true ].	
			keyString = '<Cmd-i>'
				ifTrue: [ 
					self inverseSelection.
					^ true ].
			keyString = '<Cmd-A>'
				ifTrue: [ 
					self deselectAll.
					^ true ]	].
				
	^ super navigationKey: anEvent! !

!NewList methodsFor: 'private' stamp: 'BenjaminVanRyseghem 11/25/2012 00:46'!
numberOfDisplayedItems

	^ (self innerBounds height // self itemHeight) min: self listSize! !

!NewList methodsFor: 'event handling' stamp: 'BenjaminVanRyseghem 1/28/2013 13:20'!
on: eventName send: selector to: recipient

	renderer on: eventName send: selector to: recipient! !

!NewList methodsFor: 'layout' stamp: 'BenjaminVanRyseghem 12/17/2012 14:10'!
privateFullBounds
	^  self bounds! !

!NewList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/13/2012 13:37'!
private_selectedIndexes

	^ selectedIndexes! !

!NewList methodsFor: 'communication with model' stamp: 'BenjaminVanRyseghem 11/27/2012 01:13'!
rawItemAtIndex: index

	^ self model getRawItemAt: index! !

!NewList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/26/2012 18:30'!
renderer
	^ renderer contents! !

!NewList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/26/2012 18:31'!
renderer: anObject
	renderer contents: anObject! !

!NewList methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 12/16/2012 17:49'!
resetListSelectionSilently
	
	selectedIndexes removeAll! !

!NewList methodsFor: 'private' stamp: 'BenjaminVanRyseghem 11/29/2012 16:29'!
resetSelectionIndexes

	selectedIndexes removeAll! !

!NewList methodsFor: 'communication with model' stamp: 'BenjaminVanRyseghem 11/26/2012 21:02'!
retrieveHeaderTitle

	^ self model getHeaderTitle! !

!NewList methodsFor: 'communication with model' stamp: 'BenjaminVanRyseghem 12/13/2012 09:44'!
retrieveIconMaxSize

	^ self model iconMaxSize
		ifNil: [ 0@0 ]! !

!NewList methodsFor: 'communication with model' stamp: 'BenjaminVanRyseghem 12/16/2012 17:18'!
retrieveItems

	^ self model getItems	ifNil: [ selectedItems contents ]! !

!NewList methodsFor: 'communication with model' stamp: 'BenjaminVanRyseghem 12/16/2012 17:19'!
retrieveListSize
	
	^ self model getListSize ifNil:  [ listCache size ]! !

!NewList methodsFor: 'updating - private' stamp: 'BenjaminVanRyseghem 11/29/2012 19:51'!
retrieveSelectedItem

	^ self rawItemAtIndex: self selectedIndex! !

!NewList methodsFor: 'updating - private' stamp: 'BenjaminVanRyseghem 11/29/2012 19:51'!
retrieveSelectedItems

	^ self selectedIndexes collect: [:e | self rawItemAtIndex: e ]! !

!NewList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/27/2012 01:03'!
runningProcesses
	^ runningProcesses! !

!NewList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/27/2012 01:04'!
runningProcesses: aCollection
	runningProcesses contents: aCollection! !

!NewList methodsFor: 'private' stamp: 'BenjaminVanRyseghem 11/25/2012 01:14'!
scrollToShow: aRectangle
	"scroll to include as much of aRectangle as possible, where aRectangle is in the scroller's local space"
	| range |
	
	((aRectangle top - scroller offset y - self headerHeight) >= 0 and: [
		(aRectangle bottom - scroller offset y) <= (self innerBounds height) ])
		ifTrue: [ "already visible"
			^self ].

	range := self vLeftoverScrollRange.
	scrollBar value: (range > 0
		ifTrue: [((aRectangle top-self headerHeight) / self vLeftoverScrollRange)
							truncateTo: scrollBar scrollDelta]
		ifFalse: [0]).
	scroller offset: -3 @ (range * scrollBar value).! !

!NewList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/26/2012 18:30'!
secondSelection
	^ secondSelection contents! !

!NewList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/26/2012 18:31'!
secondSelection: anObject
	secondSelection contents: anObject! !

!NewList methodsFor: 'looks & colors' stamp: 'BenjaminVanRyseghem 11/23/2012 14:48'!
secondSelectionColor

	^ self theme settings secondarySelectionColor! !

!NewList methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 11/29/2012 20:11'!
selectAll

	self isMultipleSelection ifFalse: [ ^ self ].
	
	1 to: self listSize do: [: i | selectedIndexes contents at: i put: true ].
	selectedIndexes contentsChanged.
	self secondSelection: 0.
	selectedIndex contents: self listSize.
	self changed.! !

!NewList methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 12/16/2012 17:52'!
selectSecondSelection

	 ActiveEvent commandKeyPressed ifFalse: [ selectedIndexes removeAll ].
	self setIndex: self secondSelection! !

!NewList methodsFor: 'looks & colors' stamp: 'BenjaminVanRyseghem 11/23/2012 18:07'!
selectedBackgroundColor

	^ self theme settings selectionColor! !

!NewList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/13/2012 12:07'!
selectedIndex

	^ selectedIndex contents! !

!NewList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2012 19:55'!
selectedIndexes

	^ (selectedIndexes select: [:ass | ass value ]) keys sort! !

!NewList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2012 17:00'!
selectionWithKeys
	^ selectionWithKeys contents! !

!NewList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2012 17:00'!
selectionWithKeys: anObject
	selectionWithKeys contents: anObject! !

!NewList methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 12/16/2012 17:31'!
setIndex: index

	| oldIndex newIndex |

	oldIndex := selectedIndex contents.
	newIndex := index.
	self secondSelection: 0.
	self setViewToIndex: index.
	
	selectedIndex contents: newIndex.
	(self deSelectOnReclick and: [ oldIndex == newIndex ])
		ifTrue: [ self toggleAtIndexes: newIndex ]
		ifFalse: [ self addAtIndexes: newIndex ]! !

!NewList methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 11/25/2012 01:31'!
setViewToIndex: index

	index isZero ifTrue: [ ^ self ].
	self scrollToShow: (self renderer drawBoundsForIndex: index)! !

!NewList methodsFor: 'events - keyboard' stamp: 'BenjaminVanRyseghem 11/29/2012 19:14'!
specialKeyPressed: anEvent
	"A special key with the given ascii-value was pressed; dispatch it"
	| keyString max nextSelection oldSelection howManyItemsShowing |
	
	keyString := anEvent keyString.
	keyString = '<escape>'
		ifTrue: [" escape key"
			^ ActiveEvent shiftPressed
				ifTrue: [ ActiveWorld invokeWorldMenuFromEscapeKey ]
				ifFalse: [ (self yellowButtonActivity: false) ifTrue: [ ^ self ]]].

	keyString = '<cr>'
		ifTrue: [ 
			"enter pressed" 
			self selectSecondSelection ].
		
	max := self listSize.
	max > 0 ifFalse: [ ^ self ].
	nextSelection := oldSelection := self selectedIndex.
	
	(keyString = '<down>' or: [ keyString = '<Shift-down>' ])
		ifTrue: [" down arrow"
			"self resetListSelectionSilently."
			nextSelection := oldSelection + 1.
			nextSelection := nextSelection min: max ].
	
	(keyString = '<up>' or: [ keyString = '<Shift-up>' ])
		ifTrue: [ " up arrow"
			"self resetListSelectionSilently."
			oldSelection = 0 
				ifTrue: [ nextSelection := self listSize ]
				ifFalse: [
					nextSelection := oldSelection - 1.
					nextSelection := 1 max: nextSelection ]].
		
	keyString = '<home>'
		ifTrue: [" home"
			"self resetListSelectionSilently."
			nextSelection := 1].
		
	keyString = '<end>' 
		ifTrue: [" end"
			"self resetListSelectionSilently."
			nextSelection := max].
	
	howManyItemsShowing := self numberOfDisplayedItems.
	
	keyString = '<pageUp>'
		ifTrue: 	[" page up"
			"self resetListSelectionSilently."
			nextSelection := 1 max: oldSelection - howManyItemsShowing].
	keyString = '<pageDown>'
		ifTrue: [" page down"
			"self resetListSelectionSilently."
			nextSelection := oldSelection + howManyItemsShowing min: max].

	(self enabled and: [model okToChange]) ifFalse: [ ^ self ].
	
	"No change if model is locked"
	
	oldSelection = nextSelection ifTrue: [ ^ self ].
	((anEvent shiftPressed not and: [ anEvent commandKeyPressed not ]) and: [ self selectionWithKeys ]) ifTrue: [ self resetSelectionIndexes ].
	self setIndex: nextSelection.
	anEvent shiftPressed ifTrue: [ self addAtIndexes: nextSelection ]! !

!NewList methodsFor: 'private' stamp: 'BenjaminVanRyseghem 11/25/2012 02:32'!
takesKeyboardFocus
	"Answer whether the receiver can normally take keyboard focus."

	^true! !

!NewList methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 11/29/2012 17:50'!
toggleAtIndexes: anIndex
	| bool |

	bool := selectedIndexes at: anIndex ifAbsent: [ false ].
	selectedIndexes at: anIndex put: bool not! !

!NewList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2012 20:06'!
unselectOnChange
	^ unselectOnChange contents! !

!NewList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2012 20:05'!
unselectOnChange: anObject
	unselectOnChange contents: anObject! !

!NewList methodsFor: 'updating' stamp: 'BenjaminVanRyseghem 12/17/2012 14:58'!
update: aSymbol

	aSymbol == #getItems 				ifTrue: [ ^ self updateItems ].
	aSymbol == #getListSize 				ifTrue: [ ^ self updateListSize ].
	aSymbol == #getHeaderTitle 			ifTrue: [ ^ self updateHeaderTitle ].
	aSymbol == #iconMaxSize 				ifTrue: [ ^ self updateIconMaxSize ].
	aSymbol == #iconForItem:at: 			ifTrue: [ ^ self updateIconCache ].
	aSymbol == #resetSelectedIndexes 	ifTrue: [ ^ self deselectAll ].
	aSymbol == #invalidateIcons 			ifTrue: [ ^ self invalidateIconCache ]! !

!NewList methodsFor: 'updating - private' stamp: 'BenjaminVanRyseghem 11/27/2012 01:28'!
updateDisplayListCache

	"self runningProcesses do: [:e | e ifNotNil: [:process | process terminate ]]."
	displayListCache contents: (Array new: self listSize).
	self runningProcesses: (Array new: self listSize).! !

!NewList methodsFor: 'updating - private' stamp: 'BenjaminVanRyseghem 11/26/2012 21:04'!
updateHeaderHeight
	| selector |
	self isInitialized ifFalse: [ ^ self ].
	
	headerHeight contents: self model getHeaderHeight.! !

!NewList methodsFor: 'updating' stamp: 'BenjaminVanRyseghem 11/24/2012 13:45'!
updateHeaderTitle

	self isInitialized ifFalse: [ ^ self ].

	headerTitle contents: self retrieveHeaderTitle.! !

!NewList methodsFor: 'updating' stamp: 'BenjaminVanRyseghem 12/17/2012 14:57'!
updateIconCache

	self invalidateIconCache! !

!NewList methodsFor: 'updating' stamp: 'BenjaminVanRyseghem 12/13/2012 09:45'!
updateIconMaxSize

	iconMaxSize contents: self retrieveIconMaxSize! !

!NewList methodsFor: 'updating' stamp: 'BenjaminVanRyseghem 11/23/2012 16:05'!
updateItems

	self isInitialized ifFalse: [ ^ self ].

	listCache contents: self retrieveItems! !

!NewList methodsFor: 'updating' stamp: 'BenjaminVanRyseghem 11/23/2012 16:03'!
updateListSize

	self isInitialized ifFalse: [ ^ self ].

	listSize contents: self retrieveListSize! !

!NewList methodsFor: 'updating - private' stamp: 'EstebanLorenzano 1/28/2013 15:34'!
updateRenderer

	| morph |
	self flag: 'Can we keep the same instead of removing it ?'.

	self scroller removeAllMorphs.
	morph := NewListRenderer on: self.
	morph
		color: self color;
		width: self scroller width" +10";
		hasHeader: self hasHeader;
		height: (self listSize*self itemHeight+self headerHeight).
				
	self scroller addMorph: morph.
	renderer contents: morph.! !

!NewList methodsFor: 'updating' stamp: 'BenjaminVanRyseghem 12/17/2012 14:44'!
updateScrollbars

	self setScrollDeltas.
	self scrollBar changed.
	hScrollBar changed.! !

!NewList methodsFor: 'communication with model' stamp: 'BenjaminVanRyseghem 11/27/2012 00:34'!
wantsDroppedMorph: aMorph event: anEvent

	self dropEnabled ifFalse: [ ^ false ].

	^ self model wantsDroppedMorph: aMorph event: anEvent! !

!NewList methodsFor: 'protocol - events' stamp: 'BenjaminVanRyseghem 11/24/2012 19:07'!
whenHeaderIsClickedDo: aBlock

	clickOnHeader whenChangedDo: aBlock! !

!NewList methodsFor: 'protocol - events' stamp: 'BenjaminVanRyseghem 11/24/2012 01:12'!
whenItemsChangedDo: aBlock

	listCache whenChangedDo: aBlock! !

!NewList methodsFor: 'protocol - events' stamp: 'BenjaminVanRyseghem 11/26/2012 18:47'!
whenSelectedIndexChangedDo: aBlock

	selectedIndex whenChangedDo: aBlock! !

!NewList methodsFor: 'protocol - events' stamp: 'BenjaminVanRyseghem 11/29/2012 19:34'!
whenSelectedIndexesChangedDo: aBlock

	selectedIndexes whenChangedDo: aBlock! !

!NewList methodsFor: 'protocol - events' stamp: 'BenjaminVanRyseghem 11/29/2012 19:46'!
whenSelectedItemChangedDo: aBlock

	selectedItem whenChangedDo: aBlock! !

!NewList methodsFor: 'protocol - events' stamp: 'BenjaminVanRyseghem 11/29/2012 19:46'!
whenSelectedItemsChangedDo: aBlock

	selectedItems whenChangedDo: aBlock! !

ScrollPane subclass: #NewListRenderer
	instanceVariableNames: 'itemHeight listSource maxWidth hasHeader potentialDropIndex steppingTime mouseDownIndex wantsSteps'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewList'!

!NewListRenderer commentStamp: '<historical>' prior: 0!
NewListRenderer is the morph contained by a NewList used to render all the items and manage mouse events.!

!NewListRenderer class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 11/24/2012 00:30'!
on: aNewList

	^ self new
		listSource: aNewList;
		yourself! !

!NewListRenderer methodsFor: 'drag and drop' stamp: 'BenjaminVanRyseghem 11/27/2012 00:40'!
acceptDroppingMorph: aMorph event: evt 
	"This message is sent when a morph is dropped onto a morph that has     
	agreed to accept the dropped morph by responding 'true' to the     
	wantsDroppedMorph:Event: message. The default implementation just     
	adds the given morph to the receiver."
	"Here we let the model do its work."

	[ self listSource acceptDroppingMorph: aMorph atIndex: self potentialDropIndex event: evt ] 
			ensure: [
						self resetPotentialDropIndex.
						evt hand releaseMouseFocus: self.
						Cursor normal show ]
! !

!NewListRenderer methodsFor: 'drawing - private' stamp: 'EstebanLorenzano 1/28/2013 16:10'!
basicRemoveAllMorphs
	submorphs := EmptyArray ! !

!NewListRenderer methodsFor: 'drawing - private' stamp: 'BenjaminVanRyseghem 11/24/2012 15:11'!
bottomVisibleIndexForCanvas: aCanvas
        "return the top visible index in aCanvas's clip rectangle"
        
	 | rect |
	rect := aCanvas clipRect.
	^self indexAtLocation: (rect left @ rect bottom + self headerHeight).! !

!NewListRenderer methodsFor: 'communication with model' stamp: 'BenjaminVanRyseghem 11/24/2012 14:47'!
colorForItem: item at: index 
	
	^ self listSource colorForItem: item at: index ! !

!NewListRenderer methodsFor: 'communication with model' stamp: 'BenjaminVanRyseghem 11/29/2012 18:35'!
deSelectOnReclick

	^ self listSource deSelectOnReclick! !

!NewListRenderer methodsFor: 'communication with model' stamp: 'BenjaminVanRyseghem 1/28/2013 17:45'!
doubleClickSelector

	^ self listSource doubleClickSelector! !

!NewListRenderer methodsFor: 'communication with model' stamp: 'BenjaminVanRyseghem 11/25/2012 15:51'!
dragEnabled

	^ self listSource dragEnabled! !

!NewListRenderer methodsFor: 'communication with model' stamp: 'BenjaminVanRyseghem 11/25/2012 16:02'!
dragItemSelector

	^ self listSource dragItemSelector! !

!NewListRenderer methodsFor: 'drawing - background' stamp: 'BenjaminVanRyseghem 11/29/2012 19:27'!
drawBackgroundForItem: item at: index on: aCanvas

	(self isSelectedIndex: index)
		ifTrue: [ self drawSelectedBackgroundForItem: item at: index on: aCanvas ]
		ifFalse: [ 
			(self isSecondSelectedIndex: index)
				ifTrue: [ self drawSecondSelectedItem: item at: index on: aCanvas ]
				ifFalse: [ self drawDefaultBackgroundForItem: item at: index on: aCanvas ] ].
			
	(self isPotentialDrop: index)
		ifTrue: [ self drawPotentialDropBackroundForItem: item at: index on: aCanvas ].
		
	self drawMouseDownBackgroundFor: item at: index on: aCanvas! !

!NewListRenderer methodsFor: 'drawing - private' stamp: 'BenjaminVanRyseghem 11/29/2012 19:23'!
drawBackgroundForItem: item at: index on: aCanvas color: aColor
	| frame  |
	
 	frame := self selectionFrameForItem: item at: index.
	
	aCanvas
		fillRectangle: frame
		color: aColor! !

!NewListRenderer methodsFor: 'drawing - private' stamp: 'BenjaminVanRyseghem 11/25/2012 01:30'!
drawBoundsForIndex: index
	"calculate the bounds that row should be drawn at.  This might be outside our bounds!!"

	| topLeft drawBounds |
	
	topLeft := self topLeft x @ (self topLeft y + self headerHeight + ((index - 1) * self itemHeight)).
	drawBounds := topLeft extent: self width @ self itemHeight.
	^ drawBounds! !

!NewListRenderer methodsFor: 'drawing - private' stamp: 'BenjaminVanRyseghem 12/13/2012 13:53'!
drawBoundsForItem: item at: index
	"calculate the bounds that row should be drawn at.  This might be outside our bounds!!"

	| topLeft drawBounds width |
	
	width := (item widthToDisplayInList: self) + self iconMaxSize x + self gapBetweenIconAndItem.
	(width > self maxWidth) ifTrue: [ 
		self maxWidth: width.
		self width: width ].
	topLeft := self topLeft x @ (self topLeft y + self headerHeight + ((index - 1) * self itemHeight)).
	drawBounds := topLeft extent: width @ self itemHeight.
	^ drawBounds! !

!NewListRenderer methodsFor: 'communication with model' stamp: 'BenjaminVanRyseghem 12/16/2012 17:09'!
drawColor

	^ self listSource drawColor! !

!NewListRenderer methodsFor: 'drawing - background' stamp: 'BenjaminVanRyseghem 12/5/2012 14:45'!
drawDefaultBackgroundForItem: item at: index on: aCanvas

	"Nothing to do"! !

!NewListRenderer methodsFor: 'drawing' stamp: 'BenjaminVanRyseghem 11/25/2012 20:05'!
drawHeaderOn: aCanvas
	| drawBounds top item itemColor height width deltaY deltaX |

	drawBounds := self owner bounds.
	top := self topDifference.
	drawBounds := (-3@top) corner: (drawBounds right@top + self headerHeight).
	
	aCanvas
		fillRectangle: drawBounds
		fillStyle: ((GradientFillStyle 
						ramp: {0-> (Color r: 0.854 g: 0.836 b: 0.806). 1 -> Color gray muchLighter lighter})
						origin: (drawBounds left@ drawBounds bottom);
						direction: 0@(self headerHeight negated asFloat);
						normal: 0@1;
						radial: false;
						yourself).

	item := self headerTitle.	
	itemColor := Color black.
	
	height := item heightToDisplayInList: self.
	width := item widthToDisplayInList: self.
	deltaY := (drawBounds height - height /2) asInteger.
	deltaX := (self owner width - width /2) asInteger.
	drawBounds := drawBounds translateBy: deltaX@deltaY.
	item listRenderOn: aCanvas atRow: 0 bounds: drawBounds color: itemColor from: self.! !

!NewListRenderer methodsFor: 'drawing - item' stamp: 'BenjaminVanRyseghem 12/13/2012 11:31'!
drawIconOn: aCanvas forAt: index from:  itemBounds

	| item icon maxSize drawBounds xOffset yOffset |
	
	item := self rawItemAtIndex: index.
	icon := self listSource iconForItem: item at: index.
	icon ifNil: [ ^ self ].
	
	maxSize := self iconMaxSize.
	drawBounds := itemBounds topLeft extent: maxSize.
	xOffset := maxSize x - icon width / 2.
	yOffset := maxSize y - icon height / 2 + self itemHalfOffSet.
	drawBounds := drawBounds translateBy: xOffset@yOffset.
	icon  listRenderOn: aCanvas atRow: index bounds: drawBounds color: self iconColor from: self.! !

!NewListRenderer methodsFor: 'drawing - item' stamp: 'EstebanLorenzano 1/28/2013 15:55'!
drawItem: item at: index on: aCanvas

	"Display the given item at the given row on the given
	canvas."
	
	|  itemColor drawBounds itemBounds |

	drawBounds := self drawBoundsForItem: item at: index.
	itemBounds := drawBounds translateBy: (self iconMaxSize x + self gapBetweenIconAndItem)@(2*self itemHalfOffSet).
	itemColor := self colorForItem: item at: index.
	
	item listRenderOn: aCanvas atRow: index bounds: itemBounds color: itemColor from: self.
	self drawIconOn: aCanvas forAt: index from:  drawBounds.
	
	self flag: 'should be	item drawAsListItemOn: aCanvas row: index bounds: drawBounds list: self '! !

!NewListRenderer methodsFor: 'drawing - background' stamp: 'BenjaminVanRyseghem 11/29/2012 19:28'!
drawMouseDownBackgroundFor: item at: index on: aCanvas

	index == self mouseDownIndex
		ifTrue: [	aCanvas 
					frameRectangle: (self selectionFrameForItem: item at: index)
					width: 1
					colors: {Color gray. Color transparent}
					dashes: #(1 1)]! !

!NewListRenderer methodsFor: 'drawing' stamp: 'BenjaminVanRyseghem 1/28/2013 17:05'!
drawOn: aCanvas
	| first last selectedIdx |

	aCanvas
		fillRectangle: self fullBounds
		color: self drawColor.
	
	first := self topVisibleIndexForCanvas: aCanvas.
	last := self bottomVisibleIndexForCanvas: aCanvas.
	self listSize isZero ifTrue: [ last := 0 ].
	
	first
		to: last 
		do: [ :index || item |
			item := self itemAtIndex: index.
			self drawBackgroundForItem: item at: index on: aCanvas.
			self drawItem: item at: index on: aCanvas ].
		
	self hasHeader ifTrue: [ self drawHeaderOn: aCanvas ].! !

!NewListRenderer methodsFor: 'drawing - background' stamp: 'BenjaminVanRyseghem 11/25/2012 19:44'!
drawPotentialDropBackroundForItem: item at: index on: aCanvas
	| drawBounds  |
	
	drawBounds := self drawBoundsForItem: item at: index.
	drawBounds := self ensureFrame: drawBounds.
	aCanvas frameRectangle: drawBounds color: self potentialDropColor! !

!NewListRenderer methodsFor: 'drawing - background' stamp: 'BenjaminVanRyseghem 11/24/2012 00:29'!
drawSecondSelectedItem: item at: index on: aCanvas
	
	self drawBackgroundForItem: item at: index on: aCanvas color: self secondSelectionColor.! !

!NewListRenderer methodsFor: 'drawing - background' stamp: 'BenjaminVanRyseghem 11/24/2012 00:29'!
drawSelectedBackgroundForItem: item at: index on: aCanvas

	self drawBackgroundForItem: item at: index on: aCanvas color: self selectedBackgroundColor! !

!NewListRenderer methodsFor: 'drawing' stamp: 'BenjaminVanRyseghem 12/13/2012 10:07'!
drawSubmorphsOn: aCanvas 
	"Do nothing please"! !

!NewListRenderer methodsFor: 'drag and drop' stamp: 'BenjaminVanRyseghem 11/29/2012 19:33'!
dropAcceptedMorph:  transferMorph from: sourceMorph

	self mouseDownIndex: 0.! !

!NewListRenderer methodsFor: 'communication with model' stamp: 'BenjaminVanRyseghem 11/25/2012 19:41'!
dropEnabled

	^ self listSource dropEnabled! !

!NewListRenderer methodsFor: 'communication with model' stamp: 'BenjaminVanRyseghem 11/25/2012 19:21'!
dropItemSelector

	^ self listSource dropItemSelector! !

!NewListRenderer methodsFor: 'drag and drop' stamp: 'BenjaminVanRyseghem 11/29/2012 19:33'!
dropRejectedMorph: aTransferMorp

	self resetPotentialDropIndex.
	self mouseDownIndex: 0.! !

!NewListRenderer methodsFor: 'drawing - private' stamp: 'IgorStasenko 12/22/2012 03:02'!
ensureFrame: aFrame 
	| frame |
	
	frame := aFrame.	
"??? forgot to use result ??? frame intersect: (self bounds bottom: (self bounds bottom +self headerHeight)). " 
	frame := self bounds: frame in: self listSource.
	frame := self
		bounds: ((frame left: self listSource innerBounds left) right: self listSource innerBounds right)
		from: self listSource. 
	^ frame! !

!NewListRenderer methodsFor: 'communication with model' stamp: 'BenjaminVanRyseghem 11/24/2012 00:36'!
font

	^ self listSource font! !

!NewListRenderer methodsFor: 'drawing - private' stamp: 'BenjaminVanRyseghem 12/13/2012 09:06'!
gapBetweenIconAndItem

	^ self listSource iconMaxSize 
		ifNil: [ 0 ]
		ifNotNil: [ 4 ]! !

!NewListRenderer methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 11/25/2012 02:59'!
getMenu: shiftKeyState
	"Answer the menu for this text view, supplying an empty menu to be filled in. If the menu selector takes an extra argument, pass in the current state of the shift key."

	| aMenu |
	aMenu := self listSource getMenu: shiftKeyState.
	aMenu ifNotNil: [ aMenu commandKeyHandler: self ].
	^ aMenu! !

!NewListRenderer methodsFor: 'communication with model' stamp: 'BenjaminVanRyseghem 11/25/2012 02:43'!
getMenuSelector

	^ self listSource getMenuSelector! !

!NewListRenderer methodsFor: 'events' stamp: 'BenjaminVanRyseghem 11/25/2012 19:58'!
handleMouseMove: anEvent
	"System level event handling."
	anEvent wasHandled ifTrue: [ ^ self ]. "not interested"

	anEvent wasHandled: true.
	self mouseMove: anEvent.
	(self handlesMouseStillDown: anEvent) ifTrue:[
		"Step at the new location"
		self startStepping: #handleMouseStillDown: 
			at: Time millisecondClockValue
			arguments: {anEvent copy resetHandlerFields}
			stepTime: self mouseStillDownStepRate ].
	^ self eventHandler ifNotNil: [:handler | handler mouseMove: anEvent fromMorph: self ]
! !

!NewListRenderer methodsFor: 'events' stamp: 'BenjaminVanRyseghem 11/25/2012 19:55'!
handlesMouseOverDragging: evt
	"Yes, for mouse down highlight."
	
	^true! !

!NewListRenderer methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/24/2012 13:51'!
hasHeader

	^ hasHeader contents! !

!NewListRenderer methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/24/2012 13:51'!
hasHeader: anInteger

	hasHeader contents: anInteger! !

!NewListRenderer methodsFor: 'communication with model' stamp: 'BenjaminVanRyseghem 11/29/2012 19:17'!
hasMultipledSelected

	^ self listSource hasMultipledSelected! !

!NewListRenderer methodsFor: 'communication with model' stamp: 'BenjaminVanRyseghem 11/24/2012 13:33'!
headerHeight

	^ self listSource headerHeight! !

!NewListRenderer methodsFor: 'communication with model' stamp: 'BenjaminVanRyseghem 11/24/2012 13:48'!
headerTitle

	^ self listSource headerTitle! !

!NewListRenderer methodsFor: 'drawing - private' stamp: 'BenjaminVanRyseghem 12/13/2012 09:14'!
iconColor

	^ Color transparent! !

!NewListRenderer methodsFor: 'communication with model' stamp: 'BenjaminVanRyseghem 12/13/2012 09:44'!
iconMaxSize

	^ self listSource iconMaxSize! !

!NewListRenderer methodsFor: 'drawing - private' stamp: 'BenjaminVanRyseghem 11/24/2012 13:28'!
indexAtLocation: aPoint
	"return the number of the row at aPoint"
	"Here we assume that all the item have the same height"
	| y |
	y := aPoint y.
	(y < (self top + self headerHeight)) ifTrue: [ ^ 1 ].
	^((y - self top - self headerHeight // self itemHeight) + 1) min: self listSize max: 1! !

!NewListRenderer methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 1/28/2013 17:30'!
initialize
	"Initialization code for NewListRenderer"

	super initialize.
	
	wantsSteps := false.
	listSource := nil asValueHolder.
	itemHeight := nil asValueHolder.
	maxWidth := 0 asValueHolder.
	hasHeader := false asValueHolder.
	potentialDropIndex := 0 asValueHolder.
	steppingTime := 100.
	mouseDownIndex := 0 asValueHolder.
	listSource whenChangedDo: [:e | 
		itemHeight contents: e itemHeight.
		e whenItemsChangedDo: [ maxWidth contents: 0 ]].
	potentialDropIndex whenChangedDo: [:new :old | self updateRectFor: new and: old ].
	mouseDownIndex whenChangedDo: [:new :old |
		(old ~~ 0 and: [ new ~~ 0 ]) 
			ifTrue: [ self updateRectFor: old and: new ]
			ifFalse: [
				old isZero ifFalse: [self updateRectFor: old ].
				new isZero ifFalse: [self updateRectFor: new ]]].! !

!NewListRenderer methodsFor: 'drawing - private' stamp: 'BenjaminVanRyseghem 11/24/2012 19:22'!
invalidHeader

	| rect |
	rect := self bounds.
	rect := rect topLeft extent: rect width@self headerHeight.
	self invalidRect: rect! !

!NewListRenderer methodsFor: 'communication with model' stamp: 'BenjaminVanRyseghem 11/25/2012 02:34'!
isMultipleSelection

	^ self listSource isMultipleSelection! !

!NewListRenderer methodsFor: 'drawing - private' stamp: 'BenjaminVanRyseghem 11/25/2012 19:41'!
isPotentialDrop: anIndex

	^ anIndex == self potentialDropIndex! !

!NewListRenderer methodsFor: 'private' stamp: 'BenjaminVanRyseghem 11/25/2012 21:16'!
isScrolling

	^ self isStepping! !

!NewListRenderer methodsFor: 'communication with model' stamp: 'BenjaminVanRyseghem 11/24/2012 00:36'!
isSecondSelectedIndex: index 

	^ self listSource isSecondSelectedIndex: index! !

!NewListRenderer methodsFor: 'communication with model' stamp: 'BenjaminVanRyseghem 11/24/2012 00:35'!
isSelectedIndex: index

	^ self listSource isSelectedIndex: index! !

!NewListRenderer methodsFor: 'communication with model' stamp: 'BenjaminVanRyseghem 11/24/2012 00:34'!
itemAtIndex: index

	^ self listSource itemAtIndex: index! !

!NewListRenderer methodsFor: 'communication with model' stamp: 'BenjaminVanRyseghem 11/25/2012 00:12'!
itemHalfOffSet

	^ self listSource itemHalfOffSet! !

!NewListRenderer methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/13/2012 09:46'!
itemHeight

	^ itemHeight contents! !

!NewListRenderer methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/24/2012 00:39'!
itemHeight: anInteger

	itemHeight contents: anInteger! !

!NewListRenderer methodsFor: 'communication with model' stamp: 'BenjaminVanRyseghem 11/24/2012 00:33'!
listSize
	"could be cached"
	
	^ self listSource listSize! !

!NewListRenderer methodsFor: 'communication with model' stamp: 'BenjaminVanRyseghem 11/24/2012 00:37'!
listSource
	^ listSource contents! !

!NewListRenderer methodsFor: 'communication with model' stamp: 'BenjaminVanRyseghem 11/24/2012 00:37'!
listSource: anObject
	
	listSource contents: anObject.
	! !

!NewListRenderer methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/24/2012 01:14'!
maxWidth

	^ maxWidth contents! !

!NewListRenderer methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/24/2012 01:14'!
maxWidth: anInteger

	maxWidth contents: anInteger! !

!NewListRenderer methodsFor: 'events' stamp: 'BenjaminVanRyseghem 12/16/2012 17:00'!
mouseDown: event

	| selectors index |
	
	(self enabled and: [ event yellowButtonPressed ])  "First check for option (menu) click"
		ifTrue: [
			self isMultipleSelection
				ifTrue: [ 
					event commandKeyPressed
						ifFalse: [ "right click" 
							(self yellowButtonActivity: event shiftPressed) 
								ifTrue: [ ^ self ]]]
				ifFalse: [ (self yellowButtonActivity: event shiftPressed) 
				ifTrue: [ ^ self ]]].	

	self mouseDownIndex: (self indexAtLocation: event position).

	selectors := Array 
		with: #click:
		with: (self listSource handlesDoubleClick ifTrue: [ #doubleClick: ])
		with: nil
		with: (self dragEnabled ifTrue: [ #startDrag: ] ifFalse:[ nil ]).
		
	event hand waitForClicksOrDrag: self event: event selectors: selectors threshold: 10.! !

!NewListRenderer methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2012 19:19'!
mouseDownIndex

	^ mouseDownIndex contents! !

!NewListRenderer methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2012 19:19'!
mouseDownIndex: anInteger

	mouseDownIndex contents: anInteger! !

!NewListRenderer methodsFor: 'events' stamp: 'BenjaminVanRyseghem 11/24/2012 19:08'!
mouseDownOnHeader: anEvent

	self listSource mouseDownOnHeader: anEvent! !

!NewListRenderer methodsFor: 'events' stamp: 'BenjaminVanRyseghem 11/25/2012 19:54'!
mouseLeaveDragging: evt

	self resetPotentialDropIndex.
	super mouseLeaveDragging: evt! !

!NewListRenderer methodsFor: 'events' stamp: 'BenjaminVanRyseghem 1/28/2013 17:29'!
mouseMove: evt
	| index |

	"Check if the mouse is currently dragging an object"
	evt isDraggingEvent ifFalse: [ ^ super mouseMove: evt  ].

	"Check if we are interested in this object"
	self dropEnabled ifFalse: [ ^ super mouseMove: evt ].
	(self wantsDroppedMorph: (evt hand submorphs at: 1 ifAbsent: [ ^ super mouseMove: evt ]) event: evt ) ifFalse: [ ^ super mouseMove: evt ].
	self isScrolling ifTrue: [ ^ self ].
	index := self indexAtLocation: evt position.
	self potentialDropIndex: index.
	
	(evt position y > (self topDifference + self headerHeight-10) and: [evt position y < (self topDifference + self headerHeight + 10)])
		ifTrue: [ wantsSteps := true ].
		
	(evt position y  > (self topDifference - self headerHeight + self listSource height - 5))
		ifTrue: [ wantsSteps := true ].! !

!NewListRenderer methodsFor: 'events' stamp: 'BenjaminVanRyseghem 12/16/2012 17:00'!
mouseUp: event
	| previousIndex index selectors |	
	
	self listSource wantsKeyboardFocus ifTrue: [ self listSource takeKeyboardFocus ].

	(event position y < (self topDifference + self headerHeight)) 
		ifTrue: [ ^ self mouseDownOnHeader: event ].

	index := self indexAtLocation: event position.
	previousIndex := self selectedIndex.
	
	((event shiftPressed not and: [ event commandKeyPressed not ]) and: [ self selectionWithKeys ])
		ifTrue: [ self resetSelectionIndexes ].

	self mouseDownIndex: 0.
	( self deSelectOnReclick and: [ previousIndex == index ])
		ifTrue: [ 
			self listSource private_selectedIndexes at: index put: false.
			index := 0 ].
	self listSource setIndex: index.
	self listSource mouseUpOnItemAt: index event: event.	
	
	event commandKeyPressed ifTrue: [	previousIndex = index ifTrue: [ previousIndex := 0 ]].
	event shiftPressed ifTrue: [
		| start end |
		start := previousIndex min: index.
		end := previousIndex max: index.
		
		start to: end do: [:e | self listSource addAtIndexes: e ]]! !

!NewListRenderer methodsFor: 'drawing - private' stamp: 'BenjaminVanRyseghem 11/25/2012 19:44'!
potentialDropColor

	^ Color blue! !

!NewListRenderer methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/25/2012 19:29'!
potentialDropIndex

	^ potentialDropIndex contents! !

!NewListRenderer methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/25/2012 19:28'!
potentialDropIndex: anInteger

	potentialDropIndex contents: anInteger! !

!NewListRenderer methodsFor: 'layout' stamp: 'BenjaminVanRyseghem 12/17/2012 14:09'!
privateFullBounds
	^  self bounds! !

!NewListRenderer methodsFor: 'communication with model' stamp: 'BenjaminVanRyseghem 11/25/2012 22:17'!
rawItemAtIndex: index

	^ self listSource rawItemAtIndex: index! !

!NewListRenderer methodsFor: 'private' stamp: 'BenjaminVanRyseghem 11/25/2012 15:58'!
releaseKeyboardFocus

	ActiveHand releaseKeyboardFocus.
	self listSource changed! !

!NewListRenderer methodsFor: 'private' stamp: 'BenjaminVanRyseghem 11/25/2012 19:31'!
resetPotentialDropIndex

	self potentialDropIndex: 0! !

!NewListRenderer methodsFor: 'communication with model' stamp: 'BenjaminVanRyseghem 11/29/2012 16:29'!
resetSelectionIndexes

	self listSource resetSelectionIndexes! !

!NewListRenderer methodsFor: 'communication with model' stamp: 'BenjaminVanRyseghem 11/25/2012 01:48'!
secondSelectionColor

	^ self listSource secondSelectionColor! !

!NewListRenderer methodsFor: 'communication with model' stamp: 'BenjaminVanRyseghem 11/24/2012 00:51'!
selectedBackgroundColor

	^ self listSource selectedBackgroundColor! !

!NewListRenderer methodsFor: 'communication with model' stamp: 'BenjaminVanRyseghem 11/25/2012 00:53'!
selectedIndex

	^ self listSource selectedIndex! !

!NewListRenderer methodsFor: 'communication with model' stamp: 'BenjaminVanRyseghem 12/16/2012 17:25'!
selectedIndexes

	^ self listSource selectedIndexes! !

!NewListRenderer methodsFor: 'drawing - private' stamp: 'BenjaminVanRyseghem 11/24/2012 19:18'!
selectionFrameForItem: item at: index
	"Answer the selection frame rectangle."

	| frame |
	frame := self drawBoundsForItem: item at: index.
	^ self ensureFrame: frame.! !

!NewListRenderer methodsFor: 'communication with model' stamp: 'BenjaminVanRyseghem 11/29/2012 16:59'!
selectionWithKeys

	^ self listSource selectionWithKeys! !

!NewListRenderer methodsFor: 'drag and drop' stamp: 'BenjaminVanRyseghem 12/16/2012 18:38'!
startDrag: evt 
	| transferMorph draggedIndex draggedItem passenger |

	evt hand hasSubmorphs ifTrue: [^ self]. 
	self dragEnabled ifFalse: [ ^ self ].
	ActiveHand anyButtonPressed ifFalse: [ ^ self ].
			
	draggedIndex := self indexAtLocation: evt position.
	draggedItem := self listSource model draggedItemAtIndex: draggedIndex.
	draggedItem ifNil: [ ^ self ].
	passenger := self listSource model dragPassengersFor: draggedItem inMorph: self listSource.
	passenger ifNil: [ ^ self ].
		
	self releaseKeyboardFocus.
	transferMorph := TransferMorph withPassenger: passenger from: self.
	transferMorph dropNotifyRecipient: self.
	transferMorph align: transferMorph draggedMorph bottomLeft  with: ((evt position) translateBy: (self listSource bounds left)@(self listSource bounds top - self topDifference + self headerHeight - (3*self itemHeight/2))).
	
	"self mouseDownRow: nil."
	transferMorph dragTransferType: ((self model dragTransferTypeForMorph: self) ifNil: [ #dragTransfer ]).
	
	[evt hand grabMorph: transferMorph ] 
		ensure: [
			Cursor normal show.
			evt hand releaseMouseFocus: self] ! !

!NewListRenderer methodsFor: 'stepping and presenter' stamp: 'BenjaminVanRyseghem 1/28/2013 17:32'!
step

	|  stepBounds mousePosition delta |
	ActiveHand hasSubmorphs ifFalse: [ ^ wantsSteps := false ].
	mousePosition := ActiveHand position.
	stepBounds := self listSource fullBoundsInWorld.
	(stepBounds containsPoint: mousePosition) ifFalse: [ ^ wantsSteps := false ].
	delta := stepBounds top + self headerHeight + 10 - mousePosition y.
	(mousePosition y > (stepBounds top + self headerHeight-10) and: [ 0 < delta])
		ifTrue: [ ^ self listSource scrollBar scrollUp: delta//2 ].
		
	delta := stepBounds top - self headerHeight + self listSource height - 5 - mousePosition y.
	( 0 > delta )
		ifTrue: [ ^ self listSource scrollBar scrollDown: delta negated // 3].
		
	self stopStepping.! !

!NewListRenderer methodsFor: 'stepping and presenter' stamp: 'BenjaminVanRyseghem 11/25/2012 21:04'!
stepTime

	^ steppingTime! !

!NewListRenderer methodsFor: 'communication with model' stamp: 'BenjaminVanRyseghem 12/16/2012 17:44'!
takeKeyboardFocus

	self listSource takeKeyboardFocus! !

!NewListRenderer methodsFor: 'drawing - private' stamp: 'BenjaminVanRyseghem 11/24/2012 23:42'!
topDifference
	| ownerTop top |
	
	ownerTop := self listSource top.
	top := (self bounds: self fullBounds in: self listSource) top.
	
	^ ownerTop - top +1! !

!NewListRenderer methodsFor: 'drawing - private' stamp: 'BenjaminVanRyseghem 11/25/2012 00:06'!
topVisibleIndexForCanvas: aCanvas
        "return the top visible index in aCanvas's clip rectangle"
        | rect |

	rect := aCanvas clipRect.
	^ self indexAtLocation: (rect left @ self topDifference + self headerHeight)! !

!NewListRenderer methodsFor: 'drawing - private' stamp: 'BenjaminVanRyseghem 11/25/2012 02:20'!
updateRectFor: index

	self flag: 'Could be optimized'.
	self listSource changed.
	
	"| item  |
	index isZero
		ifFalse: [
			item := self itemAtIndex: index. 
			self invalidRect:  (self selectionFrameForItem: item at: index) ]"! !

!NewListRenderer methodsFor: 'drawing - private' stamp: 'BenjaminVanRyseghem 11/25/2012 19:30'!
updateRectFor: index and: anotherIndex

	self flag: 'Could be optimized'.
	self listSource changed.
	
	"| item  |
	index isZero
		ifFalse: [
			item := self itemAtIndex: index. 
			self invalidRect:  (self selectionFrameForItem: item at: index) ]"! !

!NewListRenderer methodsFor: 'communication with model' stamp: 'BenjaminVanRyseghem 11/25/2012 19:13'!
wantsDropSelector

	^ self listSource wantsDropSelector! !

!NewListRenderer methodsFor: 'drag and drop' stamp: 'BenjaminVanRyseghem 11/27/2012 00:32'!
wantsDroppedMorph: aMorph event: anEvent

	^ self listSource wantsDroppedMorph: aMorph event: anEvent! !

!NewListRenderer methodsFor: 'stepping and presenter' stamp: 'BenjaminVanRyseghem 1/28/2013 17:31'!
wantsSteps

	^ wantsSteps! !

Model subclass: #NewListAdapter
	instanceVariableNames: 'list doubleClickSelector dragItemSelector dropItemSelector getDisplaySelector getHeaderTitleSelector getIndexSelector getItemAtIndexSelector getItemsSelector getListSizeSelector keyStrokeSelector lastKeystrokeTime lastKeystrokes model setIndexSelector wantsDropSelector getMenuSelector getMenuTitleSelector getIconSelector getIconMaxSizeSelector getIndexesSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewList'!

!NewListAdapter commentStamp: '<historical>' prior: 0!
NewListAdapter is used to link the model and the list.

It holds the "pluggable" part of the widget, aka the definition of the API!

!NewListAdapter class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 11/26/2012 18:50'!
on: aModel

	^ self new
		model: aModel;
		yourself! !

!NewListAdapter methodsFor: 'list protocol' stamp: 'BenjaminVanRyseghem 11/27/2012 00:45'!
acceptDroppingMorph: aMorph atIndex: index event: evt

	self dropItemSelector 
		ifNotNil: [| item |
			item := aMorph passenger first.
			self model perform: self dropItemSelector with: item with: index ]
		ifNil: [ 
			self model
				acceptDroppingMorph: aMorph
				event: evt
				inMorph: self ]! !

!NewListAdapter methodsFor: 'list protocol' stamp: 'BenjaminVanRyseghem 11/29/2012 19:41'!
color: aColor

	self list color: aColor! !

!NewListAdapter methodsFor: 'list protocol' stamp: 'BenjaminVanRyseghem 11/26/2012 20:28'!
deSelectOnReclick: aBoolean

	self list deSelectOnReclick: aBoolean! !

!NewListAdapter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/26/2012 18:21'!
doubleClickSelector
	^ doubleClickSelector contents! !

!NewListAdapter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/26/2012 18:21'!
doubleClickSelector: anObject
	doubleClickSelector contents: anObject! !

!NewListAdapter methodsFor: 'list protocol' stamp: 'BenjaminVanRyseghem 11/26/2012 20:27'!
dragEnabled: aBoolean

	self list dragEnabled: aBoolean! !

!NewListAdapter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/26/2012 18:21'!
dragItemSelector
	^ dragItemSelector contents! !

!NewListAdapter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/13/2012 08:32'!
dragItemSelector: anObject

	dragItemSelector contents: anObject! !

!NewListAdapter methodsFor: 'list protocol' stamp: 'BenjaminVanRyseghem 12/16/2012 18:39'!
dragPassengersFor: antem inMorph: aMorph

	^ self model dragPassengersFor: antem inMorph: aMorph! !

!NewListAdapter methodsFor: 'list protocol' stamp: 'BenjaminVanRyseghem 11/26/2012 21:27'!
draggedItemAtIndex: anIndex

	^ self dragItemSelector
			ifNil: [ self getRawItemAt: anIndex ]
			ifNotNil: [:s | self model perform: s with: anIndex  ]! !

!NewListAdapter methodsFor: 'list protocol' stamp: 'BenjaminVanRyseghem 11/26/2012 20:28'!
dropEnabled: aBoolean

	self list dropEnabled: aBoolean! !

!NewListAdapter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/26/2012 18:21'!
dropItemSelector
	^ dropItemSelector contents! !

!NewListAdapter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/26/2012 18:21'!
dropItemSelector: anObject
	dropItemSelector contents: anObject! !

!NewListAdapter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/26/2012 18:49'!
endOfInitialization

	getItemsSelector whenChangedDo: [:e | self list updateItems ].
	setIndexSelector contents ifNotNil: [:s |
		self list whenSelectedIndexChangedDo: [:a :b :c :d | 
			self model perform: s withEnoughArguments: {a. b. c. d } ]].

	getHeaderTitleSelector whenChangedDo: [:s | self list hasHeader: (s notNil) ].
	self list endOfInitialization! !

!NewListAdapter methodsFor: 'list protocol' stamp: 'BenjaminVanRyseghem 11/26/2012 20:55'!
getDisplayForItem: item at: index

	^ self getDisplaySelector 
			ifNil: [ item printString ]
			ifNotNil: [ :s | self model perform: s withEnoughArguments: {item. index} ]! !

!NewListAdapter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/26/2012 18:21'!
getDisplaySelector

	^ getDisplaySelector contents! !

!NewListAdapter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/26/2012 18:21'!
getDisplaySelector: anObject
	getDisplaySelector contents: anObject! !

!NewListAdapter methodsFor: 'list protocol' stamp: 'BenjaminVanRyseghem 11/26/2012 21:05'!
getHeaderHeight

	self flag: '25 should not be hardcoded'.
	 ^ self getHeaderTitleSelector 
		ifNil: [ 0 ]
		ifNotNil: [:s | 25 ]! !

!NewListAdapter methodsFor: 'list protocol' stamp: 'BenjaminVanRyseghem 11/26/2012 21:03'!
getHeaderTitle

	 ^ self getHeaderTitleSelector 
		ifNil: [ '' ]
		ifNotNil: [:s | self model perform: s ]! !

!NewListAdapter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/26/2012 18:21'!
getHeaderTitleSelector

	^ getHeaderTitleSelector contents! !

!NewListAdapter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/26/2012 18:21'!
getHeaderTitleSelector: anObject
	getHeaderTitleSelector contents: anObject! !

!NewListAdapter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/13/2012 09:16'!
getIconMaxSizeSelector

	^ getIconMaxSizeSelector contents! !

!NewListAdapter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/13/2012 09:16'!
getIconMaxSizeSelector: anObject
	getIconMaxSizeSelector contents: anObject! !

!NewListAdapter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/13/2012 08:46'!
getIconSelector
	^ getIconSelector contents! !

!NewListAdapter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/13/2012 08:46'!
getIconSelector: anObject
	getIconSelector contents: anObject! !

!NewListAdapter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/26/2012 18:21'!
getIndexSelector
	^ getIndexSelector contents! !

!NewListAdapter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/26/2012 18:21'!
getIndexSelector: anObject
	getIndexSelector contents: anObject! !

!NewListAdapter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/16/2012 18:19'!
getIndexesSelector

	^ getIndexesSelector contents! !

!NewListAdapter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/16/2012 18:19'!
getIndexesSelector: aSelector

	getIndexesSelector contents: aSelector! !

!NewListAdapter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/26/2012 18:21'!
getItemAtIndexSelector

	^ getItemAtIndexSelector contents! !

!NewListAdapter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/26/2012 18:21'!
getItemAtIndexSelector: aSelector

	getItemAtIndexSelector contents: aSelector! !

!NewListAdapter methodsFor: 'list protocol' stamp: 'BenjaminVanRyseghem 12/16/2012 17:17'!
getItems

	^ self getItemsSelector 
		ifNil: [ nil ]
		ifNotNil: [:s | self model perform: s ]! !

!NewListAdapter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/26/2012 18:21'!
getItemsSelector
	^ getItemsSelector contents! !

!NewListAdapter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/26/2012 18:21'!
getItemsSelector: anObject
	getItemsSelector contents: anObject! !

!NewListAdapter methodsFor: 'list protocol' stamp: 'BenjaminVanRyseghem 12/16/2012 17:17'!
getListSize

	^ self getListSizeSelector
		ifNil: [ nil ]
		ifNotNil: [:s | self model perform: s ]! !

!NewListAdapter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/26/2012 18:21'!
getListSizeSelector

	^ getListSizeSelector contents! !

!NewListAdapter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/26/2012 18:21'!
getListSizeSelector: aSelector

	getListSizeSelector contents: aSelector! !

!NewListAdapter methodsFor: 'list protocol' stamp: 'BenjaminVanRyseghem 11/28/2012 00:29'!
getMenu: shiftKeyState
	"Answer the menu for this text view, supplying an empty menu to be filled in. If the menu selector takes an extra argument, pass in the current state of the shift key."
	| menu aMenu aTitle |
	self getMenuSelector == nil ifTrue: [^ nil].
	menu := UIManager default newMenuIn: self for: self model.
	aTitle := self getMenuTitleSelector ifNotNil: [self model perform: self getMenuTitleSelector].
	self getMenuSelector numArgs = 1 ifTrue:
		[aMenu := self model perform: self getMenuSelector with: menu.
		aTitle ifNotNil:  [aMenu addTitle: aTitle].
		^ aMenu].
	self getMenuSelector numArgs = 2 ifTrue:
		[aMenu := self model perform: self getMenuSelector with: menu with: shiftKeyState.
		aTitle ifNotNil:  [aMenu addTitle: aTitle].
		^ aMenu].
	^ self error: 'The getMenuSelector must be a 1- or 2-keyword symbol'! !

!NewListAdapter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/26/2012 18:21'!
getMenuSelector
	^ getMenuSelector contents! !

!NewListAdapter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/26/2012 18:57'!
getMenuSelector: aSelector

	getMenuSelector contents: aSelector! !

!NewListAdapter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/28/2012 00:30'!
getMenuTitleSelector
	
	^ getMenuTitleSelector contents! !

!NewListAdapter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/28/2012 00:30'!
getMenuTitleSelector: anObject
	getMenuTitleSelector contents: anObject! !

!NewListAdapter methodsFor: 'list protocol' stamp: 'BenjaminVanRyseghem 11/26/2012 21:26'!
getRawItemAt: index

	^ self getItemAtIndexSelector
		ifNil: [ self list cacheAt: index ]
		ifNotNil: [:selector | self model perform: selector with: index ]! !

!NewListAdapter methodsFor: 'list protocol' stamp: 'BenjaminVanRyseghem 11/26/2012 21:10'!
handlesDoubleClick

	^ self doubleClickSelector notNil! !

!NewListAdapter methodsFor: 'list protocol' stamp: 'BenjaminVanRyseghem 12/13/2012 11:26'!
iconForItem: anItem at: anIndex

	^ self getIconSelector
		ifNil: [ nil ]
		ifNotNil: [:s | self model perform: s withEnoughArguments: {anItem . anIndex} ]! !

!NewListAdapter methodsFor: 'list protocol' stamp: 'BenjaminVanRyseghem 12/13/2012 09:18'!
iconMaxSize

	^ self getIconMaxSizeSelector
		ifNil: [ nil ]
		ifNotNil: [:s | self model perform: s ]! !

!NewListAdapter methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 12/16/2012 18:19'!
initialize
	"Initialization code for NewListAdapter"

	super initialize.

	doubleClickSelector := nil asValueHolder.
	dragItemSelector := nil asValueHolder.
	dropItemSelector := nil asValueHolder.
	getDisplaySelector := nil asValueHolder.
	getHeaderTitleSelector := nil asValueHolder.
	getMenuSelector := nil asValueHolder.
	getIndexSelector := nil asValueHolder.
	getItemAtIndexSelector := nil asValueHolder.
	getItemsSelector := nil asValueHolder.
	getListSizeSelector := nil asValueHolder.
	keyStrokeSelector := nil asValueHolder.
	lastKeystrokeTime := nil asValueHolder.
	lastKeystrokes := nil asValueHolder.
	model := nil asValueHolder.
	list := nil asValueHolder.
	setIndexSelector := nil asValueHolder.
	wantsDropSelector := nil asValueHolder.
	getMenuTitleSelector := nil asValueHolder.
	getIconSelector := nil asValueHolder.
	getIconMaxSizeSelector := nil asValueHolder.
	getIndexesSelector := nil asValueHolder.! !

!NewListAdapter methodsFor: 'list protocol' stamp: 'BenjaminVanRyseghem 11/29/2012 16:42'!
isMultipleSelection: aBoolean

	self list isMultipleSelection: aBoolean! !

!NewListAdapter methodsFor: 'list protocol' stamp: 'BenjaminVanRyseghem 1/28/2013 13:33'!
keyStrokeAction: anEvent

	^ self keyStrokeSelector 
		ifNil: [ false ]
		ifNotNil: [:s | (self model perform: s withEnoughArguments: { anEvent. ActiveHand shiftPressed}) = true ]! !

!NewListAdapter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/26/2012 21:12'!
keyStrokeSelector
	
	^ keyStrokeSelector contents! !

!NewListAdapter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/26/2012 18:21'!
keyStrokeSelector: anObject
	keyStrokeSelector contents: anObject! !

!NewListAdapter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/26/2012 18:51'!
list
	^ list contents! !

!NewListAdapter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/26/2012 18:51'!
list: anObject
	list contents: anObject! !

!NewListAdapter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/26/2012 18:21'!
model

	^ model contents! !

!NewListAdapter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/26/2012 18:21'!
model: anObject
	
	model contents ifNotNil: [:m | m removeDependent: self ].
	anObject ifNotNil: [anObject addDependent: self ].

	model contents: anObject! !

!NewListAdapter methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 12/13/2012 12:26'!
on: aModel getItemsSelector: getItems getDisplaySelector: getDisplay

	^ self
		model: aModel;
		getItemsSelector: getItems;
		getDisplaySelector: getDisplay;
		yourself! !

!NewListAdapter methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 11/26/2012 18:54'!
on: aModel getItemsSelector: getItems setIndexSelector: setIndex getDisplaySelector: getDisplay

	^ self
		model: aModel;
		getItemsSelector: getItems;
		setIndexSelector: setIndex;
		getDisplaySelector: getDisplay;
		yourself! !

!NewListAdapter methodsFor: 'updating' stamp: 'BenjaminVanRyseghem 12/16/2012 20:09'!
setIndexFromModel

	| index |
	index := self getIndexSelector 
				ifNil: [ ^ self ]
				ifNotNil: [:s | self model perform: s ].
			
	self list setIndex: index.! !

!NewListAdapter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/26/2012 18:21'!
setIndexSelector
	^ setIndexSelector contents! !

!NewListAdapter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/26/2012 18:21'!
setIndexSelector: anObject
	setIndexSelector contents: anObject! !

!NewListAdapter methodsFor: 'updating' stamp: 'BenjaminVanRyseghem 12/16/2012 20:38'!
setIndexesFromModel

	| indexes |
	
	indexes := self getIndexesSelector 
				ifNil: [ ^ self ]
				ifNotNil: [:s | self model perform: s ].
	
	self list adoptIndexes: indexes.! !

!NewListAdapter methodsFor: 'list protocol' stamp: 'BenjaminVanRyseghem 11/29/2012 20:06'!
unselectOnChange: aBoolean

	self list unselectOnChange: aBoolean! !

!NewListAdapter methodsFor: 'updating' stamp: 'BenjaminVanRyseghem 12/17/2012 14:56'!
update: aSymbol

	aSymbol == self getItemsSelector 			ifTrue: [ ^ self changed: #getItems ].
	aSymbol == self getListSizeSelector 		ifTrue: [ ^ self changed: #getListSize ].
	aSymbol == self getHeaderTitleSelector 		ifTrue: [ ^ self changed: #getHeaderTitle ].
	aSymbol == self getIconSelector 			ifTrue: [ ^ self changed: #iconForItem:at: ].
	aSymbol == self getIndexSelector 			ifTrue: [ ^ self setIndexFromModel ].
	aSymbol == self getIndexesSelector 		ifTrue: [ ^ self setIndexesFromModel ].
	aSymbol == #resetSelectedIndexes 		ifTrue: [ ^ self changed: #resetSelectedIndexes ].
	aSymbol == #invalidateIcons 				ifTrue: [ ^ self changed: #invalidateIcons ]! !

!NewListAdapter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/26/2012 18:21'!
wantsDropSelector
	^ wantsDropSelector contents! !

!NewListAdapter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/26/2012 18:21'!
wantsDropSelector: anObject
	wantsDropSelector contents: anObject! !

!NewListAdapter methodsFor: 'list protocol' stamp: 'BenjaminVanRyseghem 11/27/2012 00:34'!
wantsDroppedMorph: aMorph event: anEvent

	^ aMorph dragTransferType == #dragTransfer 
		ifTrue: [ 
			self dropItemSelector ifNil: [ ^ false ].
			self wantsDropSelector ifNil: [ ^ true ].
			(self model perform: self wantsDropSelector with: aMorph passenger) ]
		ifFalse: [ self model wantsDroppedMorph: aMorph event: anEvent inMorph: self ]! !

Model subclass: #NewListModel
	instanceVariableNames: 'listMorph index toggleTitle rawList pluggable textMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewList-Example'!

!NewListModel commentStamp: '<historical>' prior: 0!
NewListModel is a model used as an example for NewList behavior!

!NewListModel methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 12/16/2012 17:28'!
buildMorph
	| list |
	list :=  NewList
			on: self 
			getItemsSelector: #getItems 
			setIndexSelector: #setIndex:
			getDisplaySelector: #displayItem:.

	list adapter 
		getHeaderTitleSelector: #title;
		getMenuSelector: #menu:shifted:;
		dragEnabled: true;
		dropEnabled: true;
		isMultipleSelection: true;
		deSelectOnReclick: true;
		dropItemSelector: #drop:at:;
		getIconSelector: #iconFor:at:;
		getIconMaxSizeSelector: #iconMaxSize;
		endOfInitialization.

	list whenHeaderIsClickedDo: [ self toggleTitle ].
	list whenSelectedItemsChangedDo: [:items |
		textMorph ifNotNil: [
			textMorph setText: (String streamContents: [:s | 
				items do: [:e | s << e printString ; cr ]] )]] .
	^ list! !

!NewListModel methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 11/26/2012 17:16'!
buildMorphWithOld
	| list |
	
	pluggable := true.
	
	^ list := PluggableListMorph 
		on: self list: #getItems selected: #getIndex changeSelected: #setIndex: menu: #menu:shifted:! !

!NewListModel methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 11/29/2012 19:36'!
buildTextMorph

	^ PluggableTextMorph new! !

!NewListModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 12/13/2012 08:25'!
displayItem: anItem

	^ anItem asStringMorph color: Color red; yourself"
	^ TextInputFieldModel new
				ghostText: anItem asString."! !

!NewListModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 11/25/2012 22:22'!
drop: anItem at: anIndex

	rawList remove: anItem.
	rawList add: anItem beforeIndex: anIndex.
	self changed: #getItems! !

!NewListModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 11/23/2012 17:47'!
getIndex

	^ index! !

!NewListModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 11/25/2012 22:21'!
getItems

	^ toggleTitle 
		ifTrue: [ rawList ]
		ifFalse: [ rawList reversed ]! !

!NewListModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 12/13/2012 09:50'!
iconFor: item at:  anIndex
	| icon |
	icon := NautilusIcons iconNamed: #testGreen.
	"^ icon"
	^  IconicButton new 
						target: self;
						actionSelector: #halt;
						labelGraphic: icon ;
						color: Color transparent;
						extent: 12 @ 12;
						helpText: 'Run the tests';
						borderWidth: 0.! !

!NewListModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 12/13/2012 09:19'!
iconMaxSize

	^ 16@16! !

!NewListModel methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 12/13/2012 14:56'!
initialize
	"Initialization code for NewListModel"

	super initialize.

	pluggable := false.
	index := 0.
	toggleTitle := true.
	rawList := (1 to: 10) asOrderedCollection.
	textMorph := self buildTextMorph! !

!NewListModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/23/2012 15:47'!
listMorph
	^ listMorph! !

!NewListModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/23/2012 15:47'!
listMorph: anObject
	listMorph := anObject! !

!NewListModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 11/25/2012 03:04'!
menu: aMenu shifted: aBoolean
	aMenu
		add: 'Foo' 
		target: self 
		selector: #halt.
	^ aMenu! !

!NewListModel methodsFor: 'initialize' stamp: 'IgorStasenko 12/20/2012 14:59'!
openInWindow

	| panel |
	panel := PanelMorph new.
	panel 
		changeProportionalLayout;
		addMorph: listMorph fullFrame: ((0@0 corner: 1@0.5) asLayoutFrame);
		addMorph: textMorph fullFrame: ((0@0.5 corner: 1@1) asLayoutFrame); 
		yourself.
	panel openInWindow! !

!NewListModel methodsFor: 'initialize' stamp: 'IgorStasenko 12/20/2012 15:00'!
openInWorld

	| panel |
	panel := PanelMorph new.
	panel 
		changeProportionalLayout;
		addMorph: listMorph fullFrame: ((0@0 corner: 1@0.5) asLayoutFrame);
		addMorph: textMorph fullFrame: ((0@0.5 corner: 1@1) asLayoutFrame); 
		yourself.
	panel openInWorld! !

!NewListModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 11/26/2012 17:16'!
setIndex: idx

	pluggable 
		ifTrue: [
			idx = index
				ifTrue: [ index := 0 ]
				ifFalse: [ index := idx ].
			self changed: #getIndex ].! !

!NewListModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 11/25/2012 22:21'!
title

	^ toggleTitle
		ifTrue: [ 'Title' ]
		ifFalse: [ 'Title (reversed)' ]! !

!NewListModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 11/24/2012 19:36'!
toggleTitle

	toggleTitle := toggleTitle not.
	self changed: #title.
	self changed: #getItems.! !

!NewListModel methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 11/26/2012 17:14'!
withNewList

	listMorph := self buildMorph.! !

!NewListModel methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 11/26/2012 17:15'!
withOldList

	listMorph := self buildMorphWithOld.! !
